#!/bin/bash
PrOgRaM="${0##*/}"
function Error_Avortant(){ echo -e "\nERROR in ${PrOgRaM}: ${1}.\nAborting ...\n" ;  exit $2 ; }
#
if [ -n "$1" ] ; then  PaRtNuMbEr="$1" ; else read -p "Enter the number of participants in the draw: " PaRtNuMbEr ; fi
if ! [[ $PaRtNuMbEr =~ ^[[:digit:]]+$ ]] || [ $PaRtNuMbEr -lt 2 ] ; then Error_Avortant "illegal number of participants" 1 ; fi
#
clear
NuMpAr=0
DrAwOrDeR=$( seq 1 $PaRtNuMbEr | shuf )
FiTxEr="/tmp/${PrOgRaM}-${USER}-${$}.png" ; rm -f "/tmp/${PrOgRaM}-${USER}"-*.png
for SortingOrder in $DrAwOrDeR ; do  NuMpAr=$(( $NuMpAr + 1 ))
    echo ; read -s -n 1 -p "Participant $NuMpAr: Please, press any key to get your draw order ..." ; echo
    echo -e "\nThe draw order of participant $NuMpAr is: $SortingOrder"
    AmPlAdA=$(echo "scale=0; (`echo ${SortingOrder} | wc -c`-1)*350+80;" | bc)
    convert -size "$AmPlAdA"x400 xc:" #ffffbd" -font Bookman-DemiItalic -fill "rgb(235,141,47)" -draw "gravity center font-size 500 stroke magenta text -30,-10 '${SortingOrder}'" -gaussian 0x1 "$FiTxEr"
    display -title "Draw order of participant\ ${NuMpAr}" "$FiTxEr" &
done
#
clear
echo -e "Final summary of the draw:\n"
NuMpAr=0
for SortingOrder in $DrAwOrDeR ; do  NuMpAr=$(( $NuMpAr + 1 ))
    echo "Participant $NuMpAr draw order: $SortingOrder"
done
#
echo ; read -s -n 1 -p "Press any key to end the draw ..." ; echo
rm -f "/tmp/${PrOgRaM}-${USER}"-*.png
PIDsToKill="$( ps -ef | grep display | awk '/title Draw order of participant/{print $2}' )"
for n in $PIDsToKill ; do kill -KILL $n ; done
#
exit 0
#

